#!/usr/bin/perl
#########################--INFO--################################
#  By Joshua Curtis
#  http://www.curtisonline.net
#
# COPYRIGHT:
# This program is free software; you can redistribute it and/or
# modify it under the terms of the GNU General Public License
# as published by the Free Software Foundation; either version 2
# of the License, or (at your option) any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
#######################--REVISION LIST--########################
#    1/24/00 v0.4 Added a option for port for each site in the config file. 
#		If its not defined it will use 21 as the default. 
#		Also did some code cleanup
#
#    10/8/99 v0.3 Now the config file is used for all options also
#	the directory that the files are tranfered from is created on the
#	fly with a random name inside the one you define. Also the auto_ftp.pl 
#	will check the auto_ftp.conf and if the permitions are not corect 
#	(600 owner root) it will not run. kill -1 does work but kill -HUP 
#	does not i will be looking into this. Also you now can define users 
#	that are alowed to send files. If the persons id is not in the 
#	config file, there file is deleted (not sent) and mail is sent to root.
#
#    10/99 v0.2 Many changes.. Read from config file on startup and on
#	kill -HUP .  Watch multiple directories.
#
#    9/99 v0.1 script first made public - wow a day to remember
#	there may be bugs....
#
###### do not edit these ####################
use Net::FTP;
use File::Copy;
#+++++++++++++ EDIT THESE ++++++++++++++++#

###########################################
# config file for auto_ftp.pl
###########################################
my $config_file = "/etc/auto_ftp.conf";

#++++++++++++++ END EDIT +++++++++++++++++#

&get_configs;

sub signal_handler{
$time_to_die = 1;
}

$SIG{INT} = $SIG{TERM} = \&signal_handler;
$SIG{HUP} = \&get_configs;

until ($time_to_die){
		#added cleanup before files is moved to tmp_send to 
		#make sure that no on puts files in there to send out.
		&cleanup;

foreach $line (@watch_dirs){

        $line =~ s/\s//g;
	$ldir = $line. "_ldir";
	$uname = $line. "_username";
	$upass = $line. "_password";
	$ip = $line. "_ip";
	$rdir = $line. "_rdir";
	$users = $line . "_users";
	$port = $line . "_port";
	
	&search_dir($settings{$ldir},$settings{$uname},$settings{$upass},$settings{$ip},$settings{$rdir},$line,$settings{$users},$settings{$port});
}

&cleanup($local_tmp_send);
sleep($wait_time);

}

###########################################
sub search_dir{
local($local_send_directory,$username,$password,$server,$remote_directory,$site,$ausers,$port) = @_;

$folder=&generate_random;
$local_tmp = "$local_tmp_send\/$folder";

opendir(DIR, $local_send_directory) or die "Can't opendir $local_send_directory: $!";
	
	while(defined($filename = readdir(DIR)))
	{
	next if $filename =~ /^\.\.?$/;
	
	$uid = (stat($filename))[2];
	@allowed = split(/\,/ , $ausers);
	
	$doit = 0;
	$bad_uid = ();
		foreach $line (@allowed)
		{
			$cuser = getpwuid($uid);
			if ( $cuser eq $line or $doit ne 0)
			{
				$doit = 1;
			}
			else
			{
				$bad_uid .= getpwuid($uid);
			}
		}
		
		if ($doit and $filename)
		{
			chdir($local_tmp_send);mkdir($folder,"0700"); 
        		$worked=move("$local_send_directory\/$filename","$local_tmp\/$filename");
	
			while ( $worked ne "1" )
			{
				sleep(5);
				$worked=move("$local_send_directory/$filename","$local_tmp/$filename");
			}


			if ($worked eq 1){
				if ($port eq "")
				{
					$port = "21";
				}
				$ftp = Net::FTP->new($server, Port=>$port) or warn "Cant't connect: $@\n";
				$ftp->login($username, $password) or warn "Couldn't login\n";
				$logfileinfo="";
				&traverse($local_tmp,$remote_directory,$site);
				$ftp->quit();
			}

		}else{	
			system("/bin/rm -rf $local_send_directory\/$filename");
		
			open(MAIL, "|/bin/mail -s \"AUTO_FTP ERROR\" root");
			print MAIL "User(s) \"$bad_uid\" tried to send \"$filename\" to the site \"$site\"\nThe file was delted and not sent";
			close(MAIL);
		}

	
	}
closedir(DIR);
}

###########################################
sub cleanup{

opendir(DIR, $local_tmp_send) or die "Can't opendir $local_send_directory: $!";

while(defined($file = readdir(DIR)))
{
	next if $file =~ /^\.\.?$/;
	rmdir($file);
	$total="$local_tmp_send/$file";
	unlink($total);
}

closedir(DIR);
}

###########################################

sub traverse {
   local($dir) = shift;
   local($remote_directory) = shift;
   local($site) = shift;
   local($path);
   local($logfileinfo);
   unless (opendir(DIR, $dir)) {
	warn "Can't open $dir\n";
	closedir(DIR);
	return;
    }
    foreach (readdir(DIR)) {
next if $_ eq '.' || $_ eq '..' ;
	$path = "$dir/$_";
	if (-d $path) {		
	      &traverse($path,$remote_directory,$site);
	     } else {
	
$filename= $_;
$directory_create = $path;
$directory_upload_from = $path;

$directory_create =~ s/^$local_tmp\///;
$directory_create =~ s/\/$filename$//;
$directory_create =~ s/$filename$//;
$directory_upload_from =~ s/\/$filename//;

chdir($directory_upload_from);

$ftp->mkdir("$remote_directory\/$directory_create","true") or warn "Couldn't create directory\n";
$ftp->cwd("$remote_directory\/$directory_create") or warn "Couldn't change directory\n";

if (-B $filename){$ftp->binary;}
elsif (-T $filename){$ftp->ascii;}

$ftp->put($filename) or $puterror = "Couldn't put $filename\n";

$t=time();
$now=localtime($t);

open(OUTPUT, ">> $logfile") or die "Can't open log file $logfile: $!";
print OUTPUT "[$now]|$site|$filename|$directory_upload_from|$remote_directory\/$directory_create|$puterror\n";
close(OUTPUT);

unlink($filename);
chdir("../");
rmdir($directory_upload_from) if $directory_upload_from ne $local_tmp_send;

      }
   }
  closedir(DIR); 

}
###########################################

sub get_configs {

($uid,$mode) = (stat($config_file))[4,2];

if ($uid ne "0" or $mode ne "33152")
{
	die "Config file is not set to 700 and owned by root\n" ;
}
                                 
open(CONFIG, "<$config_file") or die "Can't open config file $config_file: $!";
while (<CONFIG>) {
    chomp;                  # no newline
    s/\#.*//;                # no comments
    s/^\s+//;               # no leading white
    s/\s+$//;               # no trailing white
    next unless length;     # anything left?
    my ($var, $value) = split(/\s*=\s*/, $_, 2);
    $settings{$var} = $value;
} 
close(CONFIG);
@watch_dirs = split(/,/ , $settings{sites});
$time_to_die = 0;

$wait_time = $settings{wait_time};
$local_tmp_send = $settings{local_tmp_send};
$logfile = $settings{logfile};


}

###########################################

sub generate_random
	{
	srand (time|$$);
	$rnd = int(rand(10000000));
	$rnd .= "_$$";
	$rnd =~ s/-//g;
	return $rnd;
	}

